PROGRAM prg_TUV
  VAR
  TP_restart                : TP;

  MFT1_teplota_TUV_FVE      : MFT1;
  MFT1_CFG_struct_TUV_FVE   : _TMFT1_CFG_ := (Hyst := 0.5,
                                              Tup := T#30s,
                                              Tdw := T#30s);

  L1_procenta_prikon_spirala     : REAL;
  L2_procenta_prikon_spirala     : REAL;
  L3_procenta_prikon_spirala     : REAL;

  PID_L1                    : PID21;
  PID_L2                    : PID21;
  PID_L3                    : PID21;


  //pro zobrazení na webu
  L1_prikon                  : REAL;
  L2_prikon                  : REAL;
  L3_prikon                  : REAL;
  celkem_prikon              : REAL;

  L1_suma_prikon             : REAL;
  L2_suma_prikon             : REAL;
  L3_suma_prikon             : REAL;
  celkem_suma_prikon         : REAL;

  L1_suma_prikon2             : REAL;
  L2_suma_prikon2             : REAL;
  L3_suma_prikon2             : REAL;
  celkem_suma_prikon2         : REAL;

  TIME_ACTION_vynuluj        : fb_TimeAction ;


  END_VAR

    TP_restart(IN := byl_studeny_restart OR byl_teply_restart, PT := T#10m);
    
    MFT1_teplota_TUV_FVE(In  := RP2_IN_teplota_TUV,
                         Rq  := pozadovana_teplota_TUV_FVE,
                         Cfg := MFT1_CFG_struct_TUV_FVE);

    L1_procenta_prikon_spirala := ABS(MAX(MIN(0,(RH_Elektromer_IN.P1 / 10)),-100));
    L2_procenta_prikon_spirala := ABS(MAX(MIN(0,(RH_Elektromer_IN.P2 / 10)),-100));
    L3_procenta_prikon_spirala := ABS(MAX(MIN(0,(RH_Elektromer_IN.P3 / 10)),-100));

    PID_L1(ACT :=  TRUE,                        // aktivace
           MSR :=  L1_procenta_prikon_spirala,  // měřená hodnota
           RQR :=  PID_TUV_rqr,                 // žádaná hodnota
           CFI :=  PID_TUV_CFI_stuct);              // řídící struktura

    PID_L2(ACT :=  TRUE,                        // aktivace
           MSR :=  L2_procenta_prikon_spirala,  // měřená hodnota
           RQR :=  PID_TUV_rqr,                 // žádaná hodnota
           CFI :=  PID_TUV_CFI_stuct);              // řídící struktura

    PID_L3(ACT :=  TRUE,                        // aktivace
           MSR :=  L3_procenta_prikon_spirala,  // měřená hodnota
           RQR :=  PID_TUV_rqr,                 // žádaná hodnota
           CFI :=  PID_TUV_CFI_stuct);              // řídící struktura




  IF RR_FVE_dohrev_TUV OR RP2_IN_TC_pozadavek_topna_spirala THEN
      IF MFT1_teplota_TUV_FVE.Out AND RP2_IN_tepelna_pojistka_bojler THEN
          RP2_OUT_PWM_L1  := 100;
          RP2_OUT_PWM_L2  := 100;
          RP2_OUT_PWM_L3  := 100;

          L1_prikon        := 1000;
          L2_prikon        := 1000;
          L3_prikon        := 1000;
          celkem_prikon    := 3000;
      ELSE
          RP2_OUT_PWM_L1  := 0;
          RP2_OUT_PWM_L2  := 0;
          RP2_OUT_PWM_L3  := 0;
      END_IF;

  ELSIF FVE_dohrev_TUV_povoleno  THEN
      IF  MFT1_teplota_TUV_FVE.Out AND RP2_IN_tepelna_pojistka_bojler AND NOT TP_restart.Q THEN
          RP2_OUT_PWM_L1 := REAL_TO_USINT(100.0 - PID_L1.OUT);
          RP2_OUT_PWM_L2 := REAL_TO_USINT(100.0 - PID_L2.OUT);
          RP2_OUT_PWM_L3 := REAL_TO_USINT(100.0 - PID_L3.OUT);
      ELSE
          RP2_OUT_PWM_L1  := 0;
          RP2_OUT_PWM_L2  := 0;
          RP2_OUT_PWM_L3  := 0;
      END_IF;

  ELSE
      RP2_OUT_PWM_L1  := 0;
      RP2_OUT_PWM_L2  := 0;
      RP2_OUT_PWM_L3  := 0;
  END_IF;


  TIME_ACTION_vynuluj(enable := true, timeOfAction1 := T#00h10m01s);
  IF FVE_dohrev_TUV_povoleno AND NOT RR_FVE_dohrev_TUV THEN
      // zobrazení na webu  W
      L1_prikon                  := (100.0 - PID_L1.OUT) * 10;     //příkon
      L2_prikon                  := (100.0 - PID_L2.OUT) * 10;
      L3_prikon                  := (100.0 - PID_L3.OUT) * 10;
      celkem_prikon              :=  L1_prikon + L2_prikon +  L3_prikon;

      //Wh
      IF M_DT_100ms_R_EDGE AND (L1_prikon > 0 OR L2_prikon > 0 OR L3_prikon > 0) THEN
         L1_suma_prikon       := L1_suma_prikon + L1_prikon  * 0.000028;     //celkový příkon za den
         L2_suma_prikon       := L2_suma_prikon + L2_prikon  * 0.000028;
         L3_suma_prikon       := L3_suma_prikon + L3_prikon  * 0.000028;
         celkem_suma_prikon   := celkem_suma_prikon + (L1_prikon + L2_prikon + L3_prikon) * 0.000028;
      END_IF;
  END_IF;


      IF M_DT_100ms_R_EDGE AND RH_Elektromer_IN.P1 > 0 AND L1_prikon > 0 THEN
         L1_suma_prikon2       := L1_suma_prikon2 + RH_Elektromer_IN.P1  * 0.000028;
         celkem_suma_prikon2   := celkem_suma_prikon2 + RH_Elektromer_IN.P1 * 0.000028;
      END_IF;

      IF M_DT_100ms_R_EDGE AND RH_Elektromer_IN.P2 > 0 AND L2_prikon > 0 THEN
         L2_suma_prikon2       := L2_suma_prikon2 + RH_Elektromer_IN.P2  * 0.000028;
         celkem_suma_prikon2   := celkem_suma_prikon2 + RH_Elektromer_IN.P2 * 0.000028;
      END_IF;

      IF RH_Elektromer_IN.P3 > 0  AND M_DT_100ms_R_EDGE AND L3_prikon > 0 THEN
         L3_suma_prikon2       := L3_suma_prikon2 + RH_Elektromer_IN.P3  * 0.000028;
         celkem_suma_prikon2   := celkem_suma_prikon2 + RH_Elektromer_IN.P3 * 0.000028;
      END_IF;



  IF TIME_ACTION_vynuluj.out1 THEN
      L1_suma_prikon             := 0;
      L2_suma_prikon             := 0;
      L3_suma_prikon             := 0;
      celkem_suma_prikon         := 0;

      L1_suma_prikon2            := 0;
      L2_suma_prikon2            := 0;
      L3_suma_prikon2            := 0;
      celkem_suma_prikon2        := 0;

  END_IF;

  byl_teply_restart                   :=  FALSE;
  byl_studeny_restart                 :=  FALSE;
END_PROGRAM